# bottalk.tcl -- TCL wrapper for bottalk.
#
# Copyright (C) 1999 Joel Rosdahl
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#        
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Joel Rosdahl <joel@rosdahl.net>
#
# $Id: bottalk.tcl,v 1.2 1999/09/26 20:25:58 joel Exp $

bind dcc n "sakta" dcc_sakta
bind dcc n "snabbt" dcc_snabbt

bind pubm - "*$botnick*" pub_snacka

set snabbsnack 0

proc dcc_sakta {hand idx arg} {
    global snabbsnack
    set snabbsnack 0
}

proc dcc_snabbt {hand idx arg} {
    global snabbsnack
    set snabbsnack 1
}

proc snacka {channel nick uhost handle fras} {
    global snabbsnack
    global botnick

    set pipa [open "| echo \"$fras\" | bottalk/talk $botnick $nick" r]

    while {! [eof $pipa]} {
        set response [gets $pipa]

        regsub -all "\[\[\]" $response "\\\[" response
        regsub -all "\[\]\]" $response "\\\]" response
        regsub -all "\"" $response "\\\"" response
        
        if {$snabbsnack} {
            putserv "PRIVMSG $channel :$response"
        } {
            # 3 tecken i sekunden skriver han...
            utimer [expr [rand 5] + [string length $response] / 3] "putserv \"PRIVMSG $channel :$response\""
        }
        # if public speak, add to log
        utimer 2 "putloglev p $channel \"<$botnick> $response\""
    }
    close $pipa

    return 1
}

proc pub_snacka {nick uhost hand channel text} {
  regsub -all "\[<|>\]" "$text" "" text
  snacka $channel $nick $uhost $hand $text
}

proc msg_speak {nick uhost hand text} {
  regsub -all \" $text "" text
  speak $nick $nick $uhost $hand $text
}

putlog "Loaded bottalk"
